9个Promise面试题

作者: 产品分类  发布:2020-01-03

图片 1

  1. 多个.catch

    var p = new Promise((resolve, reject) = { reject(Error('The Fails!'))})p.catch(error = console.log(error.message))p.catch(error = console.log(error.message))

以上代码的输出将会是什么?请选择正确的答案:

[ ] 打印一次消息[x] 打印两次消息[ ]UnhandledPromiseRejectionWarning[ ] 程序退出

解析:

我们使用构造函数方法创建一个 Promise,并通过reject回调立即触发错误。

然后.catch工作方式类似于 DOM 的.addEventListener(event,callback)或 Event Emitter 的.on(event,callback),其中可以添加多个回调。每个都用同样的参数进行调用。

  1. 多个.catch

    var p = new Promise((resolve, reject) = { return Promise.reject(Error('The Fails!'))})p.catch(error = console.log(error.message))p.catch(error = console.log(error.message))

以上代码的输出将会是什么?请选择正确的答案:

[ ] 打印一次消息[ ] 打印两次消息[x]UnhandledPromiseRejectionWarning[ ] 程序退出

解析:

使用 Promise 构造函数时,必须调用resolve()或reject()回调。 Promise 构造函数不使用你的返回值,因此实际上不会再收到由Promise.reject()创建的其他 Promise。

在Promise.reject()之后没有.catch时,答案是UnhandledPromiseRejectionWarning。

  1. 链接.then和.catch

    var p = new Promise((resolve, reject) = { reject(Error('The Fails!')) }) .catch(error = console.log(error)) .then(error = console.log(error))

以上代码的输出将会是什么?请选择正确的答案:

[x] 打印错误和undefined[ ] 打印两次错误[ ]UnhandledPromiseRejectionWarning[ ]undefined

解析

当链接.then和.catch时,将它们视为一系列步骤会很有帮助。每个.then都接收前一个.then返回的值作为其参数。但是,如果你的 “step” 遇到错误,则任何后续的.then“ steps” 都将被跳过,直到遇到.catch。如果要覆盖错误,你要做的就是返回一个非错误值。可以通过任何随后的.then访问。

提示:console.log()总是返回undefined。

  1. 链接.catch

    var p = new Promise((resolve, reject) = { reject(Error('The Fails!')) }) .catch(error = console.log(error.message)) .catch(error = console.log(error.message))

以上代码的输出将会是什么?请选择正确的答案:

[x] 打印一次错误消息[ ] 打印两次错误消息[ ] UnhandledPromiseRejectionWarning[ ] 程序退出

解析

当链接.catch时,每个仅处理先前的.then或`.catch“步骤” 中引发的错误。在此例中,第一个.catch返回console.log,只能通过在两个.catch之后添加.then()来访问。

  1. 多个.catch

    new Promise((resolve, reject) = { resolve('Success!') }) .then(() = { throw Error('Oh noes!') }) .catch(error = { return "actually, that worked" }) .catch(error = console.log(error.message))

以上代码的输出将会是什么?请选择正确的答案:

[ ] 打印一次消息[ ] 打印两次消息[ ] UnhandledPromiseRejectionWarning[x] 不打印任何内容

解析

提示:.catch可以简单地通过返回一个常规值来忽略错误。

该技巧仅在随后的.then接收该值时有效。

6..then之间的流程

Promise.resolve('Success!') .then(data = { return data.toUpperCase() }) .then(data = { console.log(data) })

以上代码的输出将会是什么?请选择正确的答案:

[ ] 打印 "Success!" 和 "SUCCESS!"[ ] 打印 "Success!"[x] 打印 "SUCCESS!"[ ] 不打印任何内容

解析

提示:.then依次传递数据,从return value到下一个.then(value = /* handle value */)。

为了将值传递给下一个.then,return是关键。

7..then之间的流程

Promise.resolve('Success!') .then(data = { return data.toUpperCase() }) .then(data = { console.log(data) return data }) .then(console.log)

以上代码的输出将会是什么?请选择正确的答案:

[ ] 打印 "SUCCESS!"[ ] 打印 "Success!"[x] 打印 "SUCCESS!" 和 "SUCCESS!"[ ] 不打印任何内容

解析:

有两个console.log调用将被调用。

8..then之间的流程

Promise.resolve('Success!') .then(data = { data.toUpperCase() }) .then(data = { console.log(data) })

以上代码的输出将会是什么?请选择正确的答案:

[ ] 打印 "SUCCESS!"[ ] 打印 "Success!"[ ] 打印 "SUCCESS!" 和 "SUCCESS!"[x] 打印undefined

解析:

提示:.then依次传递数据,从返回值到下一个.then(value = /* handle value */)。

为了将值传递给下一个.then,return是关键。

9..then和.catch之间的流程

Promise.resolve('Success!') .then(() = { throw Error('Oh noes!') }) .catch(error = { return 'actually, that worked' }) .then(data = { throw Error('The fails!') }) .catch(error = console.log(error.message))

以上代码的输出将会是什么?请选择正确的答案:

[ ] 打印 "Oh noes!" 和 "The fails!"[ ] 打印 "Oh noes!"”[x] 打印 "The fails!"[ ] 打印 "actually, that worked"[ ] 不打印任何内容

原文:

本文由全球彩票历史版本发布于产品分类,转载请注明出处:9个Promise面试题

关键词:

上一篇:全局方法注册全球彩票历史版本
下一篇:没有了